#!/usr/bin/perl
# v0.1 vp 13.10.2007
# v0.2 13.10.2007 Basic-Zeilen knnen sich ber mehrere Zeilen erstrecken
# v0.3 13.10.2007 GOSUB und THEN gendert (THEN wird intern als ; dargestellt !!)
# v0.4 16.10.2007 Kommentare

#$ARGV[0] = 'i:/hobby/rechner/TINY/jens mueller/grafiktest.basic';
$debug = 0;


die <<HELP unless @ARGV;
Aufruf: basic2tiny.pl textdatei
konvertiert Basic-Listings in komprimierte TINY-Format
es erfolgt kein syntaktischer Check!
HELP

# neue Dateiendung .tiny
($OUT = $ARGV[0]) =~ s/\..*/.tiny/i;

open IN, "<$ARGV[0]";
open OUT, ">$OUT";
binmode OUT;

print "Schreibe $OUT ";

# Hauptschleife
$noch_daten = 1;
while ($noch_daten) {
	$line = getline ();
	next unless $line;

	# Zeile komprimieren
	$line = packline ($line);

	# Zeile speichern
	print OUT $line, "\x0d";
}
# Schlubyte schreiben
print OUT "\x00";
close IN;
close OUT;



my $nextline;

# BASISC-Zeile holen. Diese beginnt mit einer Zahl, weitere Zeilen werden hinzugefgt,
# solange diese nicht mit einer Zahl beginnen
sub getline () {
	my $line = $nextline;

	while (1) {		
		$_ = <IN>;
#print;		
		chomp;
		if (/^\s*\d+/) { # neue BASIC-Zeile
			$nextline = $_;
			return $line;
		} else {
			$line .= $_;
		}
		
		if (eof(IN)) {
			$noch_daten = 0;
			return $line;
		}
	}
}

# Konvertieren einer BASIC-Zeile ind komprimierte Tiny-Format
sub packline ($) {
	my $line = shift;
	# Aufspalten in Zeilennummer und Zeilentext
  	my ($linenumber, $line) = $line =~ /(\d+)\s*(.*)/;
	
	print $linenumber,': ',$line,"\n" if $debug;
  	$line = pack_basic_line($line);
	print $linenumber,': ',$line,"\n" if $debug;
	
	# laut Emu ist Bit15 der Zeilennummer gesetzt, deswegen +0x8000
	return pack("n",$linenumber+0x8000).$line;
}


# eine Zeile expandieren, Strings aber nicht!
sub pack_basic_line {
	my $line = shift;

	$line =~ s//\$/g;	# Ochsenkopf
	$line =~ s//\x0A/g;	# Pfeil runter (cursor down)

	my $out;
	my @a = split /(")/, $line;
	foreach $i (0..@a) {
		if ($i%4==0) { $out .= pack_basic ($a[$i]) } else { $out .= $a[$i] }
	}
	$out;
}


# Konvertieren der BASIC-Token
sub pack_basic {
	$_ = shift;
	s/\s+//g;	# Leerzeichen lschen

  	s/LET/L/g;
  	s/PROC/O/g;
  	s/GOTO/G/g;
  	s/IF/F/g;
#  	s/THEN/,/g;
  	s/THEN/;/g;	# vp071014: laut Emu wird THEN zum ;
  	s/ELSE/>/g;
  	s/RETURN/R/g;
  	s/GOSUB/S/g;
  	s/WAIT/W/g;
  	s/REM/M/g;
  	s/CALL/C/g;
  	s/STOP/T/g;
  	s/END/E/g;
  	s/TRAP/!/g;
  	s/CLRTRAP/\//g;	# offizieller Befehlsname
  	s/TOFF/\//g;
  	s/PRINT/P/g;
  	s/PTH/H/g;
  	s/PRINTHEX/H/g;	# offizieller Befehlsname
  	s/INPUT/I/g;
	$_;
} 

